package kalkulator;

/*
 * U kalkulatoru je uvek zapisan aktivan izraz, a inicijalno je on postavljen na konstantu 0. 
 * Svaki put kad korisnik pozove neku operaciju, ona se primeni, sto ima za efekat da se drvo izraza promeni.
 */
public class Kalkulator {

	private Izraz aktivniIzraz=new Konstanta(0);
	
	public void saberi(float v){
		aktivniIzraz=new Sabirak(aktivniIzraz,new Konstanta(v));
	}
	
	public void oduzmi(float v){
		aktivniIzraz=new Razlika(aktivniIzraz,new Konstanta(v));
}
	
	public void pomnozi(float v){
		aktivniIzraz=new Proizvod(aktivniIzraz,new Konstanta(v));
	}
	
	public void podeli(float v){
		aktivniIzraz=new Kolicnik(aktivniIzraz,new Konstanta(v));
	}
	
	/* Ispis na kalkulator je predstavljen izrazom i njegovom vrednoscu, i jedno i drugo se racunaju
	 * rekurzivno, obilaskom drveta u redosledu levo poddrvo, koren, desno poddrvo.
	 */
	@Override
	public String toString() {
		return "Vrednost izraza "+aktivniIzraz.toString()+" je "+aktivniIzraz.vrednost();
	}
	
	public void resetuj(){
		System.out.println("Resetujem kalkulator");
		aktivniIzraz=new Konstanta(0);
	}
}
